local main_frame = CreateFrame("Frame");

--Function to add prfix and colour to the the actual message.
local function mostrar_Mensaje_Usuario(mensaje)
	mensaje = mensaje or "NULL";
	local MensajeColorCoded = "|cFF2EFEF7[AutoObjectiveHidder]: |cFFFFFFFF" .. mensaje;
	--Print the message
	DEFAULT_CHAT_FRAME:AddMessage(MensajeColorCoded);
end


local function ocultar_objetivo()
	local inInstance, instanceType = IsInInstance();
	if(inInstance) then
		if(AutoObjectiveHidderOptions[instanceType]) then
			if(ObjectiveTrackerFrame:IsVisible() or ObjectiveTrackerFrame:IsShown()) then
				ObjectiveTrackerFrame:Hide();
				mostrar_Mensaje_Usuario("Objective frame is automaticly hidden for this instance!");
				mostrar_Mensaje_Usuario("Type '/aoh show' to show the objective frame.");
			end
		else
			if((not ObjectiveTrackerFrame:IsVisible()) or (not ObjectiveTrackerFrame:IsShown())) then
				ObjectiveTrackerFrame:Show();
				mostrar_Mensaje_Usuario("Objective frame is automaticly showen!");
				mostrar_Mensaje_Usuario("Type '/aoh hide' to hide it.");
			end
		end
	else
		if((not ObjectiveTrackerFrame:IsVisible()) or (not ObjectiveTrackerFrame:IsShown())) then
			ObjectiveTrackerFrame:Show();
			mostrar_Mensaje_Usuario("Objective frame is automaticly showen!");
			mostrar_Mensaje_Usuario("Type '/aoh hide' to hide it.");
		end
	end
end

--Default Settings for the addon
local function load_default_settings()
	AutoObjectiveHidderOptions.raid = true;
	AutoObjectiveHidderOptions.pvp = true;
	AutoObjectiveHidderOptions.arena = true;
	AutoObjectiveHidderOptions.party = true;
	AutoObjectiveHidderOptions.none = false;
end

local optionsFrame = CreateFrame('Frame', nil, InterfaceOptionsFramePanelContainer);
local function add_options()
	-- ADDON OPTIONS
	optionsFrame.name = 'Auto Objective Hidder';

	optionsFrame.title = optionsFrame:CreateFontString();
	optionsFrame.title:SetPoint('TOPLEFT', 16, -16);
	optionsFrame.title:SetFontObject('GameFontNormalLarge');
	optionsFrame.title:SetText('Auto Objective Hidder');

	-- Fistt Check box
	optionsFrame.hideRaid = CreateFrame('CheckButton', nil, optionsFrame, 'UICheckButtonTemplate');
	optionsFrame.hideRaid:SetSize(32, 32);
	optionsFrame.hideRaid:SetPoint('TOPLEFT', optionsFrame.title, 'BOTTOMLEFT', 0, -24);

	optionsFrame.hideRaid.text = optionsFrame.hideRaid:CreateFontString();
	optionsFrame.hideRaid.text:SetFontObject('GameFontNormal');
	optionsFrame.hideRaid.text:SetText('Hide Objective Tracker in Raid.');
	optionsFrame.hideRaid.text:SetPoint('LEFT', 36, 0);

	optionsFrame.hideRaid:SetScript('OnClick', function()
		AutoObjectiveHidderOptions.raid = optionsFrame.hideRaid:GetChecked();
	end);

	-- Second Check box
	optionsFrame.hidePVP = CreateFrame('CheckButton', nil, optionsFrame, 'UICheckButtonTemplate');
	optionsFrame.hidePVP:SetSize(32, 32);
	optionsFrame.hidePVP:SetPoint('TOPLEFT', optionsFrame.title, 'BOTTOMLEFT', 0, -54);

	optionsFrame.hidePVP.text = optionsFrame.hidePVP:CreateFontString();
	optionsFrame.hidePVP.text:SetFontObject('GameFontNormal');
	optionsFrame.hidePVP.text:SetText('Hide Objective Tracker in BGs and RBGs.');
	optionsFrame.hidePVP.text:SetPoint('LEFT', 36, 0);

	optionsFrame.hidePVP:SetScript('OnClick', function()
		AutoObjectiveHidderOptions.pvp = optionsFrame.hidePVP:GetChecked();
	end);

	-- Third Check box
	optionsFrame.hideArenas = CreateFrame('CheckButton', nil, optionsFrame, 'UICheckButtonTemplate');
	optionsFrame.hideArenas:SetSize(32, 32);
	optionsFrame.hideArenas:SetPoint('TOPLEFT', optionsFrame.title, 'BOTTOMLEFT', 0, -84);

	optionsFrame.hideArenas.text = optionsFrame.hideArenas:CreateFontString();
	optionsFrame.hideArenas.text:SetFontObject('GameFontNormal');
	optionsFrame.hideArenas.text:SetText('Hide Objective Tracker in Arenas.');
	optionsFrame.hideArenas.text:SetPoint('LEFT', 36, 0);

	optionsFrame.hideArenas:SetScript('OnClick', function()
		AutoObjectiveHidderOptions.arena = optionsFrame.hideArenas:GetChecked();
	end);

	-- Fourth Check box
	optionsFrame.hideParty = CreateFrame('CheckButton', nil, optionsFrame, 'UICheckButtonTemplate');
	optionsFrame.hideParty:SetSize(32, 32);
	optionsFrame.hideParty:SetPoint('TOPLEFT', optionsFrame.title, 'BOTTOMLEFT', 0, -114);

	optionsFrame.hideParty.text = optionsFrame.hideParty:CreateFontString();
	optionsFrame.hideParty.text:SetFontObject('GameFontNormal');
	optionsFrame.hideParty.text:SetText('Hide Objective Tracker in Dungeons.');
	optionsFrame.hideParty.text:SetPoint('LEFT', 36, 0);

	optionsFrame.hideParty:SetScript('OnClick', function()
		AutoObjectiveHidderOptions.party = optionsFrame.hideParty:GetChecked();
	end);

	-- Fifth Check box
	optionsFrame.hideOtherInstances = CreateFrame('CheckButton', nil, optionsFrame, 'UICheckButtonTemplate');
	optionsFrame.hideOtherInstances:SetSize(32, 32);
	optionsFrame.hideOtherInstances:SetPoint('TOPLEFT', optionsFrame.title, 'BOTTOMLEFT', 0, -144);

	optionsFrame.hideOtherInstances.text = optionsFrame.hideOtherInstances:CreateFontString();
	optionsFrame.hideOtherInstances.text:SetFontObject('GameFontNormal');
	optionsFrame.hideOtherInstances.text:SetText('Hide Objective Tracker in Other Instances (Scenario...).');
	optionsFrame.hideOtherInstances.text:SetPoint('LEFT', 36, 0);

	optionsFrame.hideOtherInstances:SetScript('OnClick', function()
		AutoObjectiveHidderOptions.none = optionsFrame.hideOtherInstances:GetChecked();
	end);

	optionsFrame:SetScript("OnShow", function()
		optionsFrame.hideOtherInstances:SetChecked(AutoObjectiveHidderOptions.none);
		optionsFrame.hideParty:SetChecked(AutoObjectiveHidderOptions.party);
		optionsFrame.hideArenas:SetChecked(AutoObjectiveHidderOptions.arena);
		optionsFrame.hidePVP:SetChecked(AutoObjectiveHidderOptions.pvp);
		optionsFrame.hideRaid:SetChecked(AutoObjectiveHidderOptions.raid);
	end);
	
	InterfaceOptions_AddCategory(optionsFrame);
end

--Commands
local function load_commands()
SLASH_AUTOOBJECTIVEHIDDER1 = '/aoh';
SLASH_AUTOOBJECTIVEHIDDER2 = '/AutoObjectiveHidder';
SlashCmdList['AUTOOBJECTIVEHIDDER'] = function(cmd)
	if(cmd == "" or cmd == nil) then 
		mostrar_Mensaje_Usuario("/aoh config - Shows the config of this addon.");
		mostrar_Mensaje_Usuario("/aoh show - Shows the objective frame.");
		mostrar_Mensaje_Usuario("/aoh hide - Hides the objective frame.");
	elseif(cmd == "config") then
		InterfaceOptionsFrame_OpenToCategory(optionsFrame);
		InterfaceOptionsFrame_OpenToCategory(optionsFrame);
		mostrar_Mensaje_Usuario("Showing addons options!");
	elseif(cmd == "show") then
		if(ObjectiveTrackerFrame:IsVisible() or ObjectiveTrackerFrame:IsShown()) then
			mostrar_Mensaje_Usuario("The objective frame is already visible.");
		else
			ObjectiveTrackerFrame:Show();
			mostrar_Mensaje_Usuario("Objective frame is now showing!");
		end
	elseif(cmd == "hide") then
		if((not ObjectiveTrackerFrame:IsVisible()) or (not ObjectiveTrackerFrame:IsShown())) then
			mostrar_Mensaje_Usuario("The objective frame is already hiddend.");
		else
			ObjectiveTrackerFrame:Hide();
			mostrar_Mensaje_Usuario("The objective frame is now hidden!");
		end
	end
	
	end;
end

--Main load
main_frame:RegisterEvent("PLAYER_LOGIN");
main_frame:RegisterEvent("PLAYER_ALIVE");
-- On event script
main_frame:SetScript("OnEvent", function(self, event, arg1)
	if(event == "PLAYER_LOGIN") then
		--get the addon options
		AutoObjectiveHidderOptions = AutoObjectiveHidderOptions;
		--If options does not exists set the default one
		if(AutoObjectiveHidderOptions == nil) then
			--Create the table
			AutoObjectiveHidderOptions = {};
			--Load default settings
			load_default_settings();
		end
		--Add options to addon
		add_options();
		--Load the commands
		load_commands();
		--Addon Loaded
		mostrar_Mensaje_Usuario("All loaded correctly!");
		--check if logget in in instance, if so hide the objective tracker =)
		ocultar_objetivo();
	elseif(event == "PLAYER_ALIVE") then
		--Check if the objective needs to be hidden or not!
		ocultar_objetivo();
	end
end);
